import com.cycling74.max.*;
import java.lang.reflect.*;

public class lopReflect extends MaxObject
{
	private static final String[] INLET_ASSIST = new String[]{ "Left Operand", "Right Operand" };
	private static final String[] OUTLET_ASSIST = new String[]{ "Result", "dumpout"};

	private float[] a; // = new float[2048];
	private float[] b; // = new float[2048];
	private float[] resultat;
	private String op = "*"; // il y en faut bien un par dfaut
	private String opMethod = "calculeProduit";
	private boolean aSet = false;
	private boolean bSet = false;
	private Class myClass;
	private Method myMethod;
	
	public lopReflect(Atom[] args)
	{
		try {
			myClass = Class.forName( "lopReflect" );
		} catch (Exception e) {
			post(e + "");
		}

		declareTypedIO("al", "la");
		createInfoOutlet(false);

		declareAttribute("op", null, "setOp");

		setInletAssist(INLET_ASSIST);
		setOutletAssist(OUTLET_ASSIST);
	}

	private void setOp(Atom[] a) throws Exception
	{
		if (Atom.toOneString(a).equals("*"))
			opMethod = "calculeProduit";
		
		myMethod = myClass.getMethod(opMethod, null ); // null because, there's no argument
	}
		
	public void calcule()
		{
		if ( aSet == true && bSet == false) {
			b = new float[a.length];
		} else if (aSet == false && bSet == true) {
			a = new float[b.length];
		}
		
		try {
			resultat = new float[a.length];
			myMethod.invoke(this, null);
			outlet(0, resultat);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void bang() 
	{
		if ( aSet == true || bSet == true) {
			try {
				calcule();
			}
			catch (Exception e) {
				post(e + "");
			}
		}
		// sinon on fait rien
	}
    
	public void list(Atom[] args)
	{
		if (getInlet() == 1) {
			bSet = true;
			b = Atom.toFloat(args);
		} else {
			aSet = true;
			a = Atom.toFloat(args);

			try {
				calcule();
			}
			catch (Exception e) {
				post(e + "");
			}
			
		}
	}
		
	public void anything(String s, Atom[] args)
	{
		error("doesn't understand " + s + " " + Atom.toOneString(args));
	}
	
	public void calculeProduit()
	{
		for (int i = 0; i < a.length; i++) {
			resultat[i] = a[i] * b[i];
		}
	}
}




